"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.process = void 0;
const babelPrep_1 = __importDefault(require("@digest/jest-babel/dist/babelPrep"));
const scripts_1 = __importDefault(require("@digest/scripts"));
const typescript_1 = __importDefault(require("@digest/typescript"));
const babel_jest_1 = __importDefault(require("babel-jest"));
const typescript_2 = __importDefault(require("typescript"));
const localTsConfig = scripts_1.default.typescript ?
    require(scripts_1.default.typescript) :
    {};
const compilerOptions = Object.assign(Object.assign(Object.assign({}, typescript_1.default.compilerOptions), { module: 'esnext' }), localTsConfig.compilerOptions);
const babelConfig = babelPrep_1.default();
const babelTransformer = babel_jest_1.default.createTransformer(babelConfig);
const process = (source, sourcePath, projectConfig, transformerOptions) => {
    return babelTransformer.process(typescript_2.default.transpileModule(source, {
        compilerOptions,
        fileName: sourcePath
    }).outputText, `${sourcePath.slice(0, sourcePath.lastIndexOf('.'))}.js`, projectConfig, transformerOptions);
};
exports.process = process;
